/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison LALR(1) parsers in C++

   Copyright (C) 2002, 2003, 2004, 2005, 2006 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */


#include "asm-parse.hh"

/* User implementation prologue.  */
#line 65 "asm-parse.yy"

#include "parse/asm-scan.hh"


/* Line 317 of lalr1.cc.  */
#line 46 "asm-parse.cc"

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG							\
  for (bool yydebugcond_ = yydebug_; yydebugcond_; yydebugcond_ = false)	\
    (*yycdebug_)

/* Enable debugging if requested.  */
#if YYDEBUG

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)	\
do {							\
  if (yydebug_)						\
    {							\
      *yycdebug_ << Title << ' ';			\
      yy_symbol_print_ ((Type), (Value), (Location));	\
      *yycdebug_ << std::endl;				\
    }							\
} while (false)

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug_)				\
    yy_reduce_print_ (Rule);		\
} while (false)

# define YY_STACK_PRINT()		\
do {					\
  if (yydebug_)				\
    yystack_print_ ();			\
} while (false)

#else /* !YYDEBUG */

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_REDUCE_PRINT(Rule)
# define YY_STACK_PRINT()

#endif /* !YYDEBUG */

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab

namespace yy
{
#if YYERROR_VERBOSE

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              /* Fall through.  */
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

#endif

  /// Build a parser object.
  parser::parser (std::string &filename_yyarg, inst::ProgramBuilder &program_builder_yyarg)
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
      filename (filename_yyarg),
      program_builder (program_builder_yyarg)
  {
  }

  parser::~parser ()
  {
  }

#if YYDEBUG
  /*--------------------------------.
  | Print this symbol on YYOUTPUT.  |
  `--------------------------------*/

  inline void
  parser::yy_symbol_value_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yyvaluep);
    switch (yytype)
      {
        case 5: /* "\"integer\"" */
#line 81 "asm-parse.yy"
	{ debug_stream () << (yyvaluep->i); };
#line 177 "asm-parse.cc"
	break;
      case 6: /* "\"string\"" */
#line 80 "asm-parse.yy"
	{ debug_stream () << *(yyvaluep->s); };
#line 182 "asm-parse.cc"
	break;
      case 7: /* "\"register\"" */
#line 80 "asm-parse.yy"
	{ debug_stream () << *(yyvaluep->reg); };
#line 187 "asm-parse.cc"
	break;
       default:
	  break;
      }
  }


  void
  parser::yy_symbol_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    *yycdebug_ << (yytype < yyntokens_ ? "token" : "nterm")
	       << ' ' << yytname_[yytype] << " ("
	       << *yylocationp << ": ";
    yy_symbol_value_print_ (yytype, yyvaluep, yylocationp);
    *yycdebug_ << ')';
  }
#endif /* ! YYDEBUG */

  void
  parser::yydestruct_ (const char* yymsg,
			   int yytype, semantic_type* yyvaluep, location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yymsg);
    YYUSE (yyvaluep);

    YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

    switch (yytype)
      {
        case 3: /* "\"label\"" */
#line 77 "asm-parse.yy"
	{ delete (yyvaluep->id); };
#line 222 "asm-parse.cc"
	break;
      case 4: /* "\"label definition\"" */
#line 78 "asm-parse.yy"
	{ delete (yyvaluep->id); };
#line 227 "asm-parse.cc"
	break;
      case 6: /* "\"string\"" */
#line 75 "asm-parse.yy"
	{ delete (yyvaluep->s); };
#line 232 "asm-parse.cc"
	break;

	default:
	  break;
      }
  }

  void
  parser::yypop_ (unsigned int n)
  {
    yystate_stack_.pop (n);
    yysemantic_stack_.pop (n);
    yylocation_stack_.pop (n);
  }

  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }


  int
  parser::parse ()
  {
    /// Look-ahead and look-ahead in internal form.
    int yychar = yyempty_;
    int yytoken = 0;

    /* State.  */
    int yyn;
    int yylen = 0;
    int yystate = 0;

    /* Error handling.  */
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// Semantic value of the look-ahead.
    semantic_type yylval;
    /// Location of the look-ahead.
    location_type yylloc;
    /// The locations where the error started and ended.
    location yyerror_range[2];

    /// $$.
    semantic_type yyval;
    /// @$.
    location_type yyloc;

    int yyresult;

    YYCDEBUG << "Starting parse" << std::endl;


    /* User initialization code.  */
    #line 52 "asm-parse.yy"
{
  yylloc.begin.filename = yylloc.end.filename = &filename;
}
  /* Line 555 of yacc.c.  */
#line 313 "asm-parse.cc"
    /* Initialize the stacks.  The initial state will be pushed in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystate_stack_ = state_stack_type (0);
    yysemantic_stack_ = semantic_stack_type (0);
    yylocation_stack_ = location_stack_type (0);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* New state.  */
  yynewstate:
    yystate_stack_.push (yystate);
    YYCDEBUG << "Entering state " << yystate << std::endl;
    goto yybackup;

    /* Backup.  */
  yybackup:

    /* Try to take a decision without look-ahead.  */
    yyn = yypact_[yystate];
    if (yyn == yypact_ninf_)
      goto yydefault;

    /* Read a look-ahead token.  */
    if (yychar == yyempty_)
      {
	YYCDEBUG << "Reading a token: ";
	yychar = yylex (&yylval, &yylloc);
      }


    /* Convert token to internal form.  */
    if (yychar <= yyeof_)
      {
	yychar = yytoken = yyeof_;
	YYCDEBUG << "Now at end of input." << std::endl;
      }
    else
      {
	yytoken = yytranslate_ (yychar);
	YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
      }

    /* If the proper action on seeing token YYTOKEN is to reduce or to
       detect an error, take that action.  */
    yyn += yytoken;
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yytoken)
      goto yydefault;

    /* Reduce or error.  */
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
	if (yyn == 0 || yyn == yytable_ninf_)
	goto yyerrlab;
	yyn = -yyn;
	goto yyreduce;
      }

    /* Accept?  */
    if (yyn == yyfinal_)
      goto yyacceptlab;

    /* Shift the look-ahead token.  */
    YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

    /* Discard the token being shifted unless it is eof.  */
    if (yychar != yyeof_)
      yychar = yyempty_;

    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* Count tokens shifted since error; after three, turn off error
       status.  */
    if (yyerrstatus_)
      --yyerrstatus_;

    yystate = yyn;
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystate];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    /* If YYLEN is nonzero, implement the default value of the action:
       `$$ = $1'.  Otherwise, use the top of the stack.

       Otherwise, the following line sets YYVAL to garbage.
       This behavior is undocumented and Bison
       users should not rely upon it.  */
    if (yylen)
      yyval = yysemantic_stack_[yylen - 1];
    else
      yyval = yysemantic_stack_[0];

    {
      slice<location_type, location_stack_type> slice (yylocation_stack_, yylen);
      YYLLOC_DEFAULT (yyloc, slice, yylen);
    }
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
	  case 7:
#line 204 "asm-parse.yy"
    { program_builder.define_data_label(*(yysemantic_stack_[(1) - (1)].id)); ;}
    break;

  case 8:
#line 208 "asm-parse.yy"
    { program_builder.add_space((yysemantic_stack_[(2) - (2)].i)); ;}
    break;

  case 9:
#line 212 "asm-parse.yy"
    { program_builder.add_byte((yysemantic_stack_[(2) - (2)].i)); ;}
    break;

  case 10:
#line 215 "asm-parse.yy"
    { program_builder.add_half((yysemantic_stack_[(2) - (2)].i)); ;}
    break;

  case 11:
#line 218 "asm-parse.yy"
    { program_builder.add_word((yysemantic_stack_[(2) - (2)].i)); ;}
    break;

  case 12:
#line 220 "asm-parse.yy"
    { program_builder.add_word(new LabelExp(*(yysemantic_stack_[(2) - (2)].id))); ;}
    break;

  case 13:
#line 223 "asm-parse.yy"
    { program_builder.add_ascii((yysemantic_stack_[(2) - (2)].s)); ;}
    break;

  case 14:
#line 225 "asm-parse.yy"
    { program_builder.add_asciiz((yysemantic_stack_[(2) - (2)].s)); ;}
    break;

  case 17:
#line 235 "asm-parse.yy"
    { program_builder.define_inst_label(*(yysemantic_stack_[(1) - (1)].id)); ;}
    break;

  case 18:
#line 239 "asm-parse.yy"
    { program_builder.add_add((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 19:
#line 245 "asm-parse.yy"
    { program_builder.add_add((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 20:
#line 250 "asm-parse.yy"
    { program_builder.add_addi((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 21:
#line 255 "asm-parse.yy"
    { program_builder.add_addi((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 22:
#line 259 "asm-parse.yy"
    { program_builder.add_addu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 23:
#line 265 "asm-parse.yy"
    { program_builder.add_addu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 24:
#line 270 "asm-parse.yy"
    { program_builder.add_addiu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 25:
#line 275 "asm-parse.yy"
    { program_builder.add_addiu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 26:
#line 279 "asm-parse.yy"
    { program_builder.add_addi((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 27:
#line 284 "asm-parse.yy"
    { program_builder.add_addi((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 28:
#line 288 "asm-parse.yy"
    { program_builder.add_addiu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 29:
#line 293 "asm-parse.yy"
    { program_builder.add_addiu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 30:
#line 297 "asm-parse.yy"
    { program_builder.add_sub((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 31:
#line 303 "asm-parse.yy"
    { program_builder.add_sub((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 32:
#line 308 "asm-parse.yy"
    { program_builder.add_addi((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), new OpExp(new IntExp(0), OpExp::sub, (yysemantic_stack_[(6) - (6)].exp)));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 33:
#line 313 "asm-parse.yy"
    { program_builder.add_subu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 34:
#line 319 "asm-parse.yy"
    { program_builder.add_subu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 35:
#line 324 "asm-parse.yy"
    { program_builder.add_addiu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), new OpExp(new IntExp(0), OpExp::sub, (yysemantic_stack_[(6) - (6)].exp)));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 36:
#line 329 "asm-parse.yy"
    { program_builder.add_sub((yysemantic_stack_[(4) - (2)].reg), new Register(Register::general, Cpu::zero), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 37:
#line 334 "asm-parse.yy"
    { program_builder.add_sub((yysemantic_stack_[(2) - (2)].reg), new Register(Register::general, Cpu::zero), (yysemantic_stack_[(2) - (2)].reg));
  delete (yysemantic_stack_[(2) - (2)].reg);
;}
    break;

  case 38:
#line 338 "asm-parse.yy"
    { program_builder.add_subu((yysemantic_stack_[(4) - (2)].reg), new Register(Register::general, Cpu::zero), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 39:
#line 343 "asm-parse.yy"
    { program_builder.add_subu((yysemantic_stack_[(2) - (2)].reg), new Register(Register::general, Cpu::zero), (yysemantic_stack_[(2) - (2)].reg));
  delete (yysemantic_stack_[(2) - (2)].reg);
;}
    break;

  case 40:
#line 347 "asm-parse.yy"
    { program_builder.add_abs((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 41:
#line 352 "asm-parse.yy"
    { program_builder.add_abs((yysemantic_stack_[(2) - (2)].reg), (yysemantic_stack_[(2) - (2)].reg));
  delete (yysemantic_stack_[(2) - (2)].reg);
;}
    break;

  case 42:
#line 356 "asm-parse.yy"
    { program_builder.add_mul((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 43:
#line 362 "asm-parse.yy"
    { program_builder.add_mul((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 44:
#line 367 "asm-parse.yy"
    { program_builder.add_mul((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 45:
#line 372 "asm-parse.yy"
    { program_builder.add_div((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 46:
#line 377 "asm-parse.yy"
    { program_builder.add_div((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 47:
#line 383 "asm-parse.yy"
    { program_builder.add_div((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 48:
#line 388 "asm-parse.yy"
    { program_builder.add_divu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 49:
#line 393 "asm-parse.yy"
    { program_builder.add_divu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 50:
#line 399 "asm-parse.yy"
    { program_builder.add_divu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 51:
#line 404 "asm-parse.yy"
    { program_builder.add_rem((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 52:
#line 410 "asm-parse.yy"
    { program_builder.add_rem((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 53:
#line 415 "asm-parse.yy"
    { program_builder.add_remu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 54:
#line 421 "asm-parse.yy"
    { program_builder.add_remu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 55:
#line 426 "asm-parse.yy"
    { program_builder.add_sll((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 56:
#line 431 "asm-parse.yy"
    { program_builder.add_sll((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 57:
#line 435 "asm-parse.yy"
    { program_builder.add_sllv((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 58:
#line 441 "asm-parse.yy"
    { program_builder.add_sllv((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 59:
#line 446 "asm-parse.yy"
    { program_builder.add_sllv((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 60:
#line 452 "asm-parse.yy"
    { program_builder.add_sllv((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 61:
#line 457 "asm-parse.yy"
    { program_builder.add_sra((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 62:
#line 462 "asm-parse.yy"
    { program_builder.add_sra((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 63:
#line 466 "asm-parse.yy"
    { program_builder.add_srav((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 64:
#line 472 "asm-parse.yy"
    { program_builder.add_srav((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 65:
#line 477 "asm-parse.yy"
    { program_builder.add_srav((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 66:
#line 483 "asm-parse.yy"
    { program_builder.add_srav((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 67:
#line 488 "asm-parse.yy"
    { program_builder.add_srl((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 68:
#line 493 "asm-parse.yy"
    { program_builder.add_srl((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 69:
#line 497 "asm-parse.yy"
    { program_builder.add_srlv((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 70:
#line 503 "asm-parse.yy"
    { program_builder.add_srlv((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 71:
#line 508 "asm-parse.yy"
    { program_builder.add_srlv((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 72:
#line 514 "asm-parse.yy"
    { program_builder.add_srlv((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 73:
#line 519 "asm-parse.yy"
    { program_builder.add_rol((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 74:
#line 525 "asm-parse.yy"
    { program_builder.add_rol((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 75:
#line 530 "asm-parse.yy"
    { program_builder.add_rol((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 76:
#line 535 "asm-parse.yy"
    { program_builder.add_rol((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 77:
#line 539 "asm-parse.yy"
    { program_builder.add_ror((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 78:
#line 545 "asm-parse.yy"
    { program_builder.add_ror((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 79:
#line 550 "asm-parse.yy"
    { program_builder.add_ror((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 80:
#line 555 "asm-parse.yy"
    { program_builder.add_ror((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 81:
#line 559 "asm-parse.yy"
    { program_builder.add_and((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 82:
#line 565 "asm-parse.yy"
    { program_builder.add_and((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 83:
#line 570 "asm-parse.yy"
    { program_builder.add_andi((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 84:
#line 575 "asm-parse.yy"
    { program_builder.add_andi((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 85:
#line 579 "asm-parse.yy"
    { program_builder.add_andi((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 86:
#line 584 "asm-parse.yy"
    { program_builder.add_andi((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 87:
#line 588 "asm-parse.yy"
    { program_builder.add_or((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 88:
#line 594 "asm-parse.yy"
    { program_builder.add_or((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 89:
#line 599 "asm-parse.yy"
    { program_builder.add_ori((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 90:
#line 604 "asm-parse.yy"
    { program_builder.add_ori((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 91:
#line 608 "asm-parse.yy"
    { program_builder.add_ori((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 92:
#line 613 "asm-parse.yy"
    { program_builder.add_ori((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 93:
#line 617 "asm-parse.yy"
    { program_builder.add_xor((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 94:
#line 623 "asm-parse.yy"
    { program_builder.add_xor((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 95:
#line 628 "asm-parse.yy"
    { program_builder.add_xori((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 96:
#line 633 "asm-parse.yy"
    { program_builder.add_xori((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 97:
#line 637 "asm-parse.yy"
    { program_builder.add_xori((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 98:
#line 642 "asm-parse.yy"
    { program_builder.add_xori((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 99:
#line 646 "asm-parse.yy"
    { program_builder.add_nor((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 100:
#line 652 "asm-parse.yy"
    { program_builder.add_nor((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 101:
#line 657 "asm-parse.yy"
    { program_builder.add_nor((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 102:
#line 662 "asm-parse.yy"
    { program_builder.add_nor((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 103:
#line 666 "asm-parse.yy"
    { program_builder.add_nor((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg), new Register(Register::general, Cpu::zero));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 104:
#line 671 "asm-parse.yy"
    { program_builder.add_nor((yysemantic_stack_[(2) - (2)].reg), (yysemantic_stack_[(2) - (2)].reg), new Register(Register::general, Cpu::zero));
  delete (yysemantic_stack_[(2) - (2)].reg);
;}
    break;

  case 105:
#line 675 "asm-parse.yy"
    { program_builder.add_seq((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 106:
#line 681 "asm-parse.yy"
    { program_builder.add_seq((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 107:
#line 686 "asm-parse.yy"
    { program_builder.add_seq((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 108:
#line 691 "asm-parse.yy"
    { program_builder.add_seq((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 109:
#line 695 "asm-parse.yy"
    { program_builder.add_sne((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 110:
#line 701 "asm-parse.yy"
    { program_builder.add_sne((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 111:
#line 706 "asm-parse.yy"
    { program_builder.add_sne((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 112:
#line 711 "asm-parse.yy"
    { program_builder.add_sne((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 113:
#line 715 "asm-parse.yy"
    { program_builder.add_sge((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 114:
#line 721 "asm-parse.yy"
    { program_builder.add_sge((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 115:
#line 726 "asm-parse.yy"
    { program_builder.add_sge((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 116:
#line 731 "asm-parse.yy"
    { program_builder.add_sge((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 117:
#line 735 "asm-parse.yy"
    { program_builder.add_sgeu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 118:
#line 741 "asm-parse.yy"
    { program_builder.add_sgeu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 119:
#line 746 "asm-parse.yy"
    { program_builder.add_sgeu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 120:
#line 751 "asm-parse.yy"
    { program_builder.add_sgeu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 121:
#line 755 "asm-parse.yy"
    { program_builder.add_slt((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (6)].reg), (yysemantic_stack_[(6) - (4)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 122:
#line 761 "asm-parse.yy"
    { program_builder.add_sgt((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 123:
#line 766 "asm-parse.yy"
    { program_builder.add_sgt((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 124:
#line 770 "asm-parse.yy"
    { program_builder.add_sltu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (6)].reg), (yysemantic_stack_[(6) - (4)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 125:
#line 776 "asm-parse.yy"
    { program_builder.add_sgtu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 126:
#line 781 "asm-parse.yy"
    { program_builder.add_sgtu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 127:
#line 785 "asm-parse.yy"
    { program_builder.add_sle((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 128:
#line 791 "asm-parse.yy"
    { program_builder.add_sle((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 129:
#line 796 "asm-parse.yy"
    { program_builder.add_sle((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 130:
#line 801 "asm-parse.yy"
    { program_builder.add_sle((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 131:
#line 805 "asm-parse.yy"
    { program_builder.add_sleu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 132:
#line 811 "asm-parse.yy"
    { program_builder.add_sleu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 133:
#line 816 "asm-parse.yy"
    { program_builder.add_sleu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 134:
#line 821 "asm-parse.yy"
    { program_builder.add_sleu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 135:
#line 825 "asm-parse.yy"
    { program_builder.add_slt((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 136:
#line 831 "asm-parse.yy"
    { program_builder.add_slt((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 137:
#line 836 "asm-parse.yy"
    { program_builder.add_slti((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 138:
#line 841 "asm-parse.yy"
    { program_builder.add_slti((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 139:
#line 845 "asm-parse.yy"
    { program_builder.add_sltu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
  delete (yysemantic_stack_[(6) - (6)].reg);
;}
    break;

  case 140:
#line 851 "asm-parse.yy"
    { program_builder.add_sltu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 141:
#line 856 "asm-parse.yy"
    { program_builder.add_sltiu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 142:
#line 861 "asm-parse.yy"
    { program_builder.add_sltiu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 143:
#line 865 "asm-parse.yy"
    { program_builder.add_slti((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 144:
#line 870 "asm-parse.yy"
    { program_builder.add_slti((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 145:
#line 874 "asm-parse.yy"
    { program_builder.add_sltiu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 146:
#line 879 "asm-parse.yy"
    { program_builder.add_sltiu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 147:
#line 883 "asm-parse.yy"
    { program_builder.add_beq((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 148:
#line 888 "asm-parse.yy"
    { program_builder.add_beq((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].exp), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
;}
    break;

  case 149:
#line 892 "asm-parse.yy"
    { program_builder.add_beq((yysemantic_stack_[(4) - (2)].reg), new Register(Register::general, Cpu::zero), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 150:
#line 896 "asm-parse.yy"
    { program_builder.add_bne((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 151:
#line 901 "asm-parse.yy"
    { program_builder.add_bne((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].exp), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
;}
    break;

  case 152:
#line 905 "asm-parse.yy"
    { program_builder.add_bne((yysemantic_stack_[(4) - (2)].reg), new Register(Register::general, Cpu::zero), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 153:
#line 909 "asm-parse.yy"
    { program_builder.add_bge((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 154:
#line 914 "asm-parse.yy"
    { program_builder.add_bge((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].exp), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
;}
    break;

  case 155:
#line 918 "asm-parse.yy"
    { program_builder.add_bgeu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 156:
#line 923 "asm-parse.yy"
    { program_builder.add_bgeu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].exp), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
;}
    break;

  case 157:
#line 927 "asm-parse.yy"
    { program_builder.add_bgez((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 158:
#line 931 "asm-parse.yy"
    { program_builder.add_bgezal((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 159:
#line 935 "asm-parse.yy"
    { program_builder.add_bgt((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 160:
#line 940 "asm-parse.yy"
    { program_builder.add_bgt((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].exp), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
;}
    break;

  case 161:
#line 944 "asm-parse.yy"
    { program_builder.add_bgtu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 162:
#line 949 "asm-parse.yy"
    { program_builder.add_bgtu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].exp), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
;}
    break;

  case 163:
#line 953 "asm-parse.yy"
    { program_builder.add_bgtz((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 164:
#line 957 "asm-parse.yy"
    { program_builder.add_ble((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 165:
#line 962 "asm-parse.yy"
    { program_builder.add_ble((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].exp), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
;}
    break;

  case 166:
#line 966 "asm-parse.yy"
    { program_builder.add_bleu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 167:
#line 971 "asm-parse.yy"
    { program_builder.add_bleu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].exp), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
;}
    break;

  case 168:
#line 975 "asm-parse.yy"
    { program_builder.add_blez((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 169:
#line 979 "asm-parse.yy"
    { program_builder.add_blt((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 170:
#line 984 "asm-parse.yy"
    { program_builder.add_blt((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].exp), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
;}
    break;

  case 171:
#line 988 "asm-parse.yy"
    { program_builder.add_bltu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].reg), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (4)].reg);
;}
    break;

  case 172:
#line 993 "asm-parse.yy"
    { program_builder.add_bltu((yysemantic_stack_[(6) - (2)].reg), (yysemantic_stack_[(6) - (4)].exp), (yysemantic_stack_[(6) - (6)].exp));
  delete (yysemantic_stack_[(6) - (2)].reg);
;}
    break;

  case 173:
#line 997 "asm-parse.yy"
    { program_builder.add_bltz((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 174:
#line 1001 "asm-parse.yy"
    { program_builder.add_bltzal((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 175:
#line 1005 "asm-parse.yy"
    { program_builder.add_j((yysemantic_stack_[(2) - (2)].exp));
;}
    break;

  case 176:
#line 1008 "asm-parse.yy"
    { program_builder.add_jal((yysemantic_stack_[(2) - (2)].exp));
;}
    break;

  case 177:
#line 1011 "asm-parse.yy"
    { program_builder.add_jr((yysemantic_stack_[(2) - (2)].reg));
  delete (yysemantic_stack_[(2) - (2)].reg);
;}
    break;

  case 178:
#line 1015 "asm-parse.yy"
    { program_builder.add_jalr((yysemantic_stack_[(2) - (2)].reg));
  delete (yysemantic_stack_[(2) - (2)].reg);
;}
    break;

  case 179:
#line 1019 "asm-parse.yy"
    { program_builder.add_lb((yysemantic_stack_[(7) - (2)].reg), (yysemantic_stack_[(7) - (4)].exp), (yysemantic_stack_[(7) - (6)].reg));
  delete (yysemantic_stack_[(7) - (2)].reg);
  delete (yysemantic_stack_[(7) - (6)].reg);
;}
    break;

  case 180:
#line 1024 "asm-parse.yy"
    { program_builder.add_lb((yysemantic_stack_[(6) - (2)].reg), new IntExp(0), (yysemantic_stack_[(6) - (5)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (5)].reg);
;}
    break;

  case 181:
#line 1029 "asm-parse.yy"
    { program_builder.add_lbu((yysemantic_stack_[(7) - (2)].reg), (yysemantic_stack_[(7) - (4)].exp), (yysemantic_stack_[(7) - (6)].reg));
  delete (yysemantic_stack_[(7) - (2)].reg);
  delete (yysemantic_stack_[(7) - (6)].reg);
;}
    break;

  case 182:
#line 1034 "asm-parse.yy"
    { program_builder.add_lbu((yysemantic_stack_[(6) - (2)].reg), new IntExp(0), (yysemantic_stack_[(6) - (5)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (5)].reg);
;}
    break;

  case 183:
#line 1039 "asm-parse.yy"
    { program_builder.add_lw((yysemantic_stack_[(7) - (2)].reg), (yysemantic_stack_[(7) - (4)].exp), (yysemantic_stack_[(7) - (6)].reg));
  delete (yysemantic_stack_[(7) - (2)].reg);
  delete (yysemantic_stack_[(7) - (6)].reg);
;}
    break;

  case 184:
#line 1044 "asm-parse.yy"
    { program_builder.add_lw((yysemantic_stack_[(6) - (2)].reg), new IntExp(0), (yysemantic_stack_[(6) - (5)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (5)].reg);
;}
    break;

  case 185:
#line 1049 "asm-parse.yy"
    { program_builder.add_lui((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 186:
#line 1053 "asm-parse.yy"
    { program_builder.add_ori((yysemantic_stack_[(4) - (2)].reg), new Register(Register::general, Cpu::zero), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 187:
#line 1057 "asm-parse.yy"
    { program_builder.add_la((yysemantic_stack_[(7) - (2)].reg), (yysemantic_stack_[(7) - (4)].exp), (yysemantic_stack_[(7) - (6)].reg));
  delete (yysemantic_stack_[(7) - (2)].reg);
  delete (yysemantic_stack_[(7) - (6)].reg);
;}
    break;

  case 188:
#line 1062 "asm-parse.yy"
    { program_builder.add_la((yysemantic_stack_[(6) - (2)].reg), new IntExp(0), (yysemantic_stack_[(6) - (5)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (5)].reg);
;}
    break;

  case 189:
#line 1067 "asm-parse.yy"
    { program_builder.add_la((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].exp));
  delete (yysemantic_stack_[(4) - (2)].reg);
;}
    break;

  case 190:
#line 1071 "asm-parse.yy"
    { program_builder.add_sb((yysemantic_stack_[(7) - (2)].reg), (yysemantic_stack_[(7) - (4)].exp), (yysemantic_stack_[(7) - (6)].reg));
  delete (yysemantic_stack_[(7) - (2)].reg);
  delete (yysemantic_stack_[(7) - (6)].reg);
;}
    break;

  case 191:
#line 1076 "asm-parse.yy"
    { program_builder.add_sb((yysemantic_stack_[(6) - (2)].reg), new IntExp(0), (yysemantic_stack_[(6) - (5)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (5)].reg);
;}
    break;

  case 192:
#line 1081 "asm-parse.yy"
    { program_builder.add_sw((yysemantic_stack_[(7) - (2)].reg), (yysemantic_stack_[(7) - (4)].exp), (yysemantic_stack_[(7) - (6)].reg));
  delete (yysemantic_stack_[(7) - (2)].reg);
  delete (yysemantic_stack_[(7) - (6)].reg);
;}
    break;

  case 193:
#line 1086 "asm-parse.yy"
    { program_builder.add_sw((yysemantic_stack_[(6) - (2)].reg), new IntExp(0), (yysemantic_stack_[(6) - (5)].reg));
  delete (yysemantic_stack_[(6) - (2)].reg);
  delete (yysemantic_stack_[(6) - (5)].reg);
;}
    break;

  case 194:
#line 1091 "asm-parse.yy"
    { program_builder.add_addu((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg), new Register(Register::general, Cpu::zero));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 195:
#line 1096 "asm-parse.yy"
    { program_builder.add_mfhi((yysemantic_stack_[(2) - (2)].reg));
  delete (yysemantic_stack_[(2) - (2)].reg);
;}
    break;

  case 196:
#line 1100 "asm-parse.yy"
    { program_builder.add_mflo((yysemantic_stack_[(2) - (2)].reg));
  delete (yysemantic_stack_[(2) - (2)].reg);
;}
    break;

  case 197:
#line 1104 "asm-parse.yy"
    { program_builder.add_mthi((yysemantic_stack_[(2) - (2)].reg));
  delete (yysemantic_stack_[(2) - (2)].reg);
;}
    break;

  case 198:
#line 1108 "asm-parse.yy"
    { program_builder.add_mtlo((yysemantic_stack_[(2) - (2)].reg));
  delete (yysemantic_stack_[(2) - (2)].reg);
;}
    break;

  case 199:
#line 1112 "asm-parse.yy"
    { program_builder.add_mfc0((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 200:
#line 1117 "asm-parse.yy"
    { program_builder.add_mtc0((yysemantic_stack_[(4) - (2)].reg), (yysemantic_stack_[(4) - (4)].reg));
  delete (yysemantic_stack_[(4) - (2)].reg);
  delete (yysemantic_stack_[(4) - (4)].reg);
;}
    break;

  case 201:
#line 1122 "asm-parse.yy"
    { program_builder.add_syscall();
;}
    break;

  case 202:
#line 1125 "asm-parse.yy"
    { program_builder.add_sll(new Register(Register::general, Cpu::zero), new Register(Register::general, Cpu::zero), new IntExp(0));
;}
    break;

  case 203:
#line 1129 "asm-parse.yy"
    { (yyval.exp) = new OpExp((yysemantic_stack_[(3) - (1)].exp), OpExp::add, (yysemantic_stack_[(3) - (3)].exp)); ;}
    break;

  case 204:
#line 1130 "asm-parse.yy"
    { (yyval.exp) = new OpExp((yysemantic_stack_[(3) - (1)].exp), OpExp::sub, (yysemantic_stack_[(3) - (3)].exp)); ;}
    break;

  case 205:
#line 1131 "asm-parse.yy"
    { (yyval.exp) = new OpExp((yysemantic_stack_[(3) - (1)].exp), OpExp::mul, (yysemantic_stack_[(3) - (3)].exp)); ;}
    break;

  case 206:
#line 1132 "asm-parse.yy"
    { (yyval.exp) = new OpExp((yysemantic_stack_[(3) - (1)].exp), OpExp::div, (yysemantic_stack_[(3) - (3)].exp)); ;}
    break;

  case 207:
#line 1134 "asm-parse.yy"
    { (yyval.exp) = new OpExp(new IntExp(0), OpExp::sub, (yysemantic_stack_[(2) - (2)].exp)); ;}
    break;

  case 208:
#line 1135 "asm-parse.yy"
    { (yyval.exp) = (yysemantic_stack_[(3) - (2)].exp); ;}
    break;

  case 209:
#line 1136 "asm-parse.yy"
    { (yyval.exp) = new IntExp((yysemantic_stack_[(1) - (1)].i)); ;}
    break;

  case 210:
#line 1137 "asm-parse.yy"
    { (yyval.exp) = new LabelExp(*(yysemantic_stack_[(1) - (1)].id)); ;}
    break;


    /* Line 675 of lalr1.cc.  */
#line 1959 "asm-parse.cc"
	default: break;
      }
    YY_SYMBOL_PRINT ("-> $$ =", yyr1_[yyn], &yyval, &yyloc);

    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    yysemantic_stack_.push (yyval);
    yylocation_stack_.push (yyloc);

    /* Shift the result of the reduction.  */
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystate_stack_[0];
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystate_stack_[0])
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    goto yynewstate;

  /*------------------------------------.
  | yyerrlab -- here on detecting error |
  `------------------------------------*/
  yyerrlab:
    /* If not already recovering from an error, report this error.  */
    if (!yyerrstatus_)
      {
	++yynerrs_;
	error (yylloc, yysyntax_error_ (yystate, yytoken));
      }

    yyerror_range[0] = yylloc;
    if (yyerrstatus_ == 3)
      {
	/* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

	if (yychar <= yyeof_)
	  {
	  /* Return failure if at end of input.  */
	  if (yychar == yyeof_)
	    YYABORT;
	  }
	else
	  {
	    yydestruct_ ("Error: discarding", yytoken, &yylval, &yylloc);
	    yychar = yyempty_;
	  }
      }

    /* Else will try to reuse look-ahead token after shifting the error
       token.  */
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;

    yyerror_range[0] = yylocation_stack_[yylen - 1];
    /* Do not reclaim the symbols of the rule which action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    yystate = yystate_stack_[0];
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

    for (;;)
      {
	yyn = yypact_[yystate];
	if (yyn != yypact_ninf_)
	{
	  yyn += yyterror_;
	  if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
	    {
	      yyn = yytable_[yyn];
	      if (0 < yyn)
		break;
	    }
	}

	/* Pop the current state because it cannot handle the error token.  */
	if (yystate_stack_.height () == 1)
	YYABORT;

	yyerror_range[0] = yylocation_stack_[0];
	yydestruct_ ("Error: popping",
		     yystos_[yystate],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);
	yypop_ ();
	yystate = yystate_stack_[0];
	YY_STACK_PRINT ();
      }

    if (yyn == yyfinal_)
      goto yyacceptlab;

    yyerror_range[1] = yylloc;
    // Using YYLLOC is tempting, but would change the location of
    // the look-ahead.  YYLOC is available though.
    YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yyloc);

    /* Shift the error token.  */
    YY_SYMBOL_PRINT ("Shifting", yystos_[yyn],
		   &yysemantic_stack_[0], &yylocation_stack_[0]);

    yystate = yyn;
    goto yynewstate;

    /* Accept.  */
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    /* Abort.  */
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (yychar != yyeof_ && yychar != yyempty_)
      yydestruct_ ("Cleanup: discarding lookahead", yytoken, &yylval, &yylloc);

    /* Do not reclaim the symbols of the rule which action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (yystate_stack_.height () != 1)
      {
	yydestruct_ ("Cleanup: popping",
		   yystos_[yystate_stack_[0]],
		   &yysemantic_stack_[0],
		   &yylocation_stack_[0]);
	yypop_ ();
      }

    return yyresult;
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (int yystate, int tok)
  {
    std::string res;
    YYUSE (yystate);
#if YYERROR_VERBOSE
    int yyn = yypact_[yystate];
    if (yypact_ninf_ < yyn && yyn <= yylast_)
      {
	/* Start YYX at -YYN if negative to avoid negative indexes in
	   YYCHECK.  */
	int yyxbegin = yyn < 0 ? -yyn : 0;

	/* Stay within bounds of both yycheck and yytname.  */
	int yychecklim = yylast_ - yyn + 1;
	int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
	int count = 0;
	for (int x = yyxbegin; x < yyxend; ++x)
	  if (yycheck_[x + yyn] == x && x != yyterror_)
	    ++count;

	// FIXME: This method of building the message is not compatible
	// with internationalization.  It should work like yacc.c does it.
	// That is, first build a string that looks like this:
	// "syntax error, unexpected %s or %s or %s"
	// Then, invoke YY_ on this string.
	// Finally, use the string as a format to output
	// yytname_[tok], etc.
	// Until this gets fixed, this message appears in English only.
	res = "syntax error, unexpected ";
	res += yytnamerr_ (yytname_[tok]);
	if (count < 5)
	  {
	    count = 0;
	    for (int x = yyxbegin; x < yyxend; ++x)
	      if (yycheck_[x + yyn] == x && x != yyterror_)
		{
		  res += (!count++) ? ", expecting " : " or ";
		  res += yytnamerr_ (yytname_[x]);
		}
	  }
      }
    else
#endif
      res = YY_("syntax error");
    return res;
  }


  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
  const signed char parser::yypact_ninf_ = -69;
  const short int
  parser::yypact_[] =
  {
       -69,     6,   -69,   -69,   -69,   176,    -2,   -69,    -3,     3,
      23,    27,    30,    34,    37,    41,    44,    48,    51,    55,
      58,    62,    65,    69,    72,    76,    79,    83,    90,    93,
      97,   100,   104,   110,   111,   112,   124,   128,   130,   132,
     142,   174,   188,   275,   277,   280,   284,   287,   291,   294,
     298,   302,   308,   309,   319,   320,   322,   324,   326,   369,
     371,   374,   378,   381,   385,   388,   392,   395,   122,   122,
     399,   402,   406,   409,   413,   416,   420,   423,   427,   430,
     434,   437,   441,   444,   448,   451,   455,   -69,   -69,   -69,
     -69,   460,   464,   467,    22,   473,   480,   -69,   466,   483,
     487,   490,   494,   497,   501,   504,   508,   511,   515,   518,
     522,   525,   529,   532,   536,   539,   543,   546,   550,   553,
     557,   560,   564,   567,   571,   574,   578,   581,   585,   588,
     592,   595,   599,   602,   606,   609,   613,   616,   620,   623,
     627,   630,   634,   637,   641,   644,   648,   651,   655,   658,
     662,   665,   669,   672,   676,   679,   683,   686,   -69,   -69,
     122,   122,   831,   831,   -69,   -69,   690,   693,   697,   700,
     704,   707,   711,   714,   718,   -69,   -69,   -69,   -69,   721,
     725,   -69,   -69,   -69,   -69,   -69,   -69,   -69,     0,    21,
      28,    35,   476,   732,   735,   739,   743,   746,   750,   754,
     758,   765,    42,   766,    49,   772,    56,   773,    63,    70,
      77,    84,    91,    98,   105,   121,   278,   779,   285,   292,
     299,   372,   379,   386,   393,   400,   407,   414,   421,   428,
     435,   122,   442,   122,   449,   456,   122,   122,   463,   470,
     122,   477,   484,   122,   491,   498,   122,   122,   185,   -69,
     122,   122,   122,   122,   729,   733,   740,   122,   122,   744,
     751,   755,   780,   839,   840,   838,   831,   841,   831,   842,
     831,   843,   831,   844,   845,   -69,   -69,   -69,   846,   847,
     848,   849,   850,   851,   831,   852,   853,   831,   854,   855,
     831,   856,   857,   831,   858,   831,   859,   831,   860,   831,
     861,   831,   862,   831,   863,   831,   864,   831,   865,   831,
     -69,   866,   831,   867,   831,   868,   831,   869,   831,   870,
     831,   871,   831,   872,   831,   873,   831,   874,   831,   875,
     831,   876,   831,   877,   831,   878,   782,   831,   879,   787,
     831,   880,   792,   881,   797,   831,   831,   882,   802,   883,
     807,   831,   884,   812,   885,   817,   831,   886,   822,   887,
     827,   831,   831,   -69,   101,   101,   -69,   -69,   505,     1,
     512,   300,   519,   756,   831,   831,   526,   763,   533,   770,
     540,   777,   -69,   -69,   -69,   547,   554,   122,   122,   561,
     568,   575,   582,   589,   891,   892,   596,   893,   603,   894,
     610,   895,   617,   624,   631,   122,   638,   122,   645,   122,
     652,   659,   666,   673,   680,   687,   694,   701,   708,   715,
     722,   122,   122,   122,   122,   122,   122,   122,   122,   122,
     122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
     122,   122,   122,   481,   896,   897,   898,   899,   900,   901,
     902,   903,   904,   905,   906,   -69,   831,   -69,   831,   831,
     831,   -69,   831,   -69,   831,   -69,   831,   -69,   831,   -69,
     831,   -69,   -69,   -69,   831,   -69,   -69,   831,   -69,   -69,
     831,   -69,   -69,   831,   -69,   831,   -69,   831,   831,   -69,
     831,   831,   -69,   831,   831,   -69,   831,   -69,   831,   -69,
     831,   -69,   831,   -69,   831,   -69,   831,   -69,   831,   -69,
     831,   -69,   831,   -69,   831,   -69,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   831,   -69,
     907,   -69,   908,   -69,   909,   -69,   910,   -69,   911,   -69,
     912,   -69,   -69,   -69,   -69,   -69,   -69
  };

  /* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
     doesn't specify something else to do.  Zero means the default is an
     error.  */
  const unsigned char
  parser::yydefact_[] =
  {
         2,     0,     1,    15,     5,     3,     4,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   201,   202,    16,
       7,     0,     0,     0,     0,     0,     0,     6,     0,     0,
       0,     0,     0,     0,    37,    39,    41,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   210,   209,
       0,     0,   175,   176,   177,   178,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   195,   196,   197,   198,     0,
       0,     8,     9,    10,    12,    11,    13,    14,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   207,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    19,    21,    23,    25,     0,
      27,     0,    29,    31,    34,    36,    38,    40,    43,    45,
      48,    52,    54,    58,    56,    60,    64,    62,    66,    70,
      68,    72,    74,    76,    78,    80,    82,    84,     0,    86,
      88,    90,     0,    92,    94,    96,     0,    98,   100,   102,
     103,   106,   108,   110,   112,   114,   116,   118,   120,     0,
     123,     0,   126,   128,   130,   132,   134,   136,   138,   140,
     142,     0,   144,     0,   146,     0,     0,   149,     0,     0,
     152,     0,     0,     0,     0,   157,   158,     0,     0,     0,
       0,   163,     0,     0,     0,     0,   168,     0,     0,     0,
       0,   173,   174,   208,   204,   203,   206,   205,     0,     0,
       0,     0,     0,     0,   185,   186,     0,   189,     0,     0,
       0,     0,   194,   199,   200,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,    20,    22,    24,    26,
      28,    30,    32,    33,    35,    42,    44,    46,    47,    49,
      50,    51,    53,    57,    55,    59,    63,    61,    65,    69,
      67,    71,    73,    75,    77,    79,    81,    83,    85,    87,
      89,    91,    93,    95,    97,    99,   101,   105,   107,   109,
     111,   113,   115,   117,   119,   121,   122,   124,   125,   127,
     129,   131,   133,   135,   137,   139,   141,   143,   145,   147,
     148,   150,   151,   153,   154,   155,   156,   159,   160,   161,
     162,   164,   165,   166,   167,   169,   170,   171,   172,   180,
       0,   182,     0,   184,     0,   188,     0,   191,     0,   193,
       0,   179,   181,   183,   187,   190,   192
  };

  /* YYPGOTO[NTERM-NUM].  */
  const signed char
  parser::yypgoto_[] =
  {
       -69,   -69,   -69,   -69,   -69,   -69,   -68
  };

  /* YYDEFGOTO[NTERM-NUM].  */
  const short int
  parser::yydefgoto_[] =
  {
        -1,     1,     6,    97,     5,    89,   248
  };

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If zero, do what YYDEFACT says.  */
  const signed char parser::yytable_ninf_ = -1;
  const unsigned short int
  parser::yytable_[] =
  {
       162,   163,    90,   158,    98,   159,     2,   265,   160,   444,
      99,   161,   250,   251,   252,   253,    91,    92,    93,    94,
      95,    96,     3,     4,   158,   184,   159,   185,   267,   160,
     100,   158,   161,   159,   101,   269,   160,   102,   158,   161,
     159,   103,   271,   160,   104,   158,   161,   159,   105,   283,
     160,   106,   158,   161,   159,   107,   286,   160,   108,   158,
     161,   159,   109,   289,   160,   110,   158,   161,   159,   111,
     292,   160,   112,   158,   161,   159,   113,   294,   160,   114,
     158,   161,   159,   115,   296,   160,   116,   158,   161,   159,
     117,   298,   160,   249,   158,   161,   159,   118,   300,   160,
     119,   158,   161,   159,   120,   302,   160,   121,   158,   161,
     159,   122,   304,   160,   252,   253,   161,   123,   124,   125,
     266,   268,   270,   272,   158,   158,   159,   159,   306,   160,
     160,   126,   161,   161,   284,   127,   287,   128,   290,   129,
     293,   295,   297,   299,   301,   303,   305,   307,   309,   130,
     312,   314,   316,   318,   320,   322,   324,   326,   328,   330,
     332,   334,   336,   337,   339,   340,   342,   344,   345,   346,
     348,   350,   351,   353,   355,   356,   358,   360,   361,   362,
       7,   131,   364,   365,   366,   367,   369,   371,   373,   374,
     375,   377,   379,   381,   363,   132,   250,   251,   252,   253,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,   158,   133,   159,   134,   308,   160,   135,   158,   161,
     159,   136,   311,   160,   137,   158,   161,   159,   138,   313,
     160,   139,   158,   161,   159,   140,   315,   160,   446,   141,
     161,   250,   251,   252,   253,   142,   143,   456,   458,   459,
     460,   462,   464,   466,   468,   470,   144,   145,   474,   146,
     477,   147,   480,   148,   483,   485,   487,   488,   490,   491,
     493,   494,   496,   498,   500,   502,   504,   506,   508,   510,
     512,   514,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   158,   149,   159,   150,   317,
     160,   151,   158,   161,   159,   152,   319,   160,   153,   158,
     161,   159,   154,   321,   160,   155,   158,   161,   159,   156,
     323,   160,   157,   158,   161,   159,   164,   325,   160,   165,
     158,   161,   159,   166,   327,   160,   167,   158,   161,   159,
     168,   329,   160,   169,   158,   161,   159,   170,   331,   160,
     171,   158,   161,   159,   172,   333,   160,   173,   158,   161,
     159,   174,   335,   160,   175,   158,   161,   159,   176,   338,
     160,   177,   158,   161,   159,   178,   341,   160,   179,   158,
     161,   159,   180,   343,   160,   181,   158,   161,   159,   182,
     347,   160,   183,   158,   161,   159,   188,   349,   160,   186,
     158,   161,   159,   273,   352,   160,   187,   158,   161,   159,
     539,   354,   160,   189,   158,   161,   159,   190,   357,   160,
     191,   158,   161,   159,   192,   359,   160,   193,   158,   161,
     159,   194,   443,   160,   195,   158,   161,   159,   196,   445,
     160,   197,   158,   161,   159,   198,   447,   160,   199,   158,
     161,   159,   200,   449,   160,   201,   158,   161,   159,   202,
     451,   160,   203,   158,   161,   159,   204,   453,   160,   205,
     158,   161,   159,   206,   455,   160,   207,   158,   161,   159,
     208,   457,   160,   209,   158,   161,   159,   210,   461,   160,
     211,   158,   161,   159,   212,   463,   160,   213,   158,   161,
     159,   214,   465,   160,   215,   158,   161,   159,   216,   467,
     160,   217,   158,   161,   159,   218,   469,   160,   219,   158,
     161,   159,   220,   473,   160,   221,   158,   161,   159,   222,
     476,   160,   223,   158,   161,   159,   224,   479,   160,   225,
     158,   161,   159,   226,   482,   160,   227,   158,   161,   159,
     228,   484,   160,   229,   158,   161,   159,   230,   486,   160,
     231,   158,   161,   159,   232,   489,   160,   233,   158,   161,
     159,   234,   492,   160,   235,   158,   161,   159,   236,   495,
     160,   237,   158,   161,   159,   238,   497,   160,   239,   158,
     161,   159,   240,   499,   160,   241,   158,   161,   159,   242,
     501,   160,   243,   158,   161,   159,   244,   503,   160,   245,
     158,   161,   159,   246,   505,   160,   247,   158,   161,   159,
     254,   507,   160,   255,   158,   161,   159,   256,   509,   160,
     257,   158,   161,   159,   258,   511,   160,   259,   158,   161,
     159,   260,   513,   160,   261,   158,   161,   159,   262,   515,
     160,   263,   158,   161,   159,   264,   158,   368,   159,   274,
     161,   370,   275,   158,   161,   159,   276,   158,   372,   159,
     277,   161,   376,   278,   158,   161,   159,   279,   158,   378,
     159,   280,   161,   380,   448,   281,   161,   250,   251,   252,
     253,   450,   282,   285,   250,   251,   252,   253,   452,   288,
     291,   250,   251,   252,   253,   454,   310,   382,   250,   251,
     252,   253,   424,   250,   251,   252,   253,   426,   250,   251,
     252,   253,   428,   250,   251,   252,   253,   430,   250,   251,
     252,   253,   432,   250,   251,   252,   253,   434,   250,   251,
     252,   253,   436,   250,   251,   252,   253,   438,   250,   251,
     252,   253,   440,   250,   251,   252,   253,   442,   250,   251,
     252,   253,   250,   251,   252,   253,   383,   384,   385,     0,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   425,
     427,   429,   431,   433,   435,   437,   439,   441,   471,   472,
     475,   478,   481,   540,     0,   542,   541,   544,   543,   546,
     545,   548,   547,   550,   549,     0,   551,   552,   553,   554,
     555,   556
  };

  /* YYCHECK.  */
  const short int
  parser::yycheck_[] =
  {
        68,    69,     4,     3,     7,     5,     0,     7,     8,     8,
       7,    11,    11,    12,    13,    14,    18,    19,    20,    21,
      22,    23,    16,    17,     3,     3,     5,     5,     7,     8,
       7,     3,    11,     5,     7,     7,     8,     7,     3,    11,
       5,     7,     7,     8,     7,     3,    11,     5,     7,     7,
       8,     7,     3,    11,     5,     7,     7,     8,     7,     3,
      11,     5,     7,     7,     8,     7,     3,    11,     5,     7,
       7,     8,     7,     3,    11,     5,     7,     7,     8,     7,
       3,    11,     5,     7,     7,     8,     7,     3,    11,     5,
       7,     7,     8,   161,     3,    11,     5,     7,     7,     8,
       7,     3,    11,     5,     7,     7,     8,     7,     3,    11,
       5,     7,     7,     8,    13,    14,    11,     7,     7,     7,
     188,   189,   190,   191,     3,     3,     5,     5,     7,     8,
       8,     7,    11,    11,   202,     7,   204,     7,   206,     7,
     208,   209,   210,   211,   212,   213,   214,   215,   216,     7,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       4,     7,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     9,     7,    11,    12,    13,    14,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     3,     7,     5,     7,     7,     8,     7,     3,    11,
       5,     7,     7,     8,     7,     3,    11,     5,     7,     7,
       8,     7,     3,    11,     5,     7,     7,     8,     8,     7,
      11,    11,    12,    13,    14,     7,     7,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     7,     7,   396,     7,
     398,     7,   400,     7,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     3,     7,     5,     7,     7,
       8,     7,     3,    11,     5,     7,     7,     8,     7,     3,
      11,     5,     7,     7,     8,     7,     3,    11,     5,     7,
       7,     8,     7,     3,    11,     5,     7,     7,     8,     7,
       3,    11,     5,     7,     7,     8,     7,     3,    11,     5,
       7,     7,     8,     7,     3,    11,     5,     7,     7,     8,
       7,     3,    11,     5,     7,     7,     8,     7,     3,    11,
       5,     7,     7,     8,     7,     3,    11,     5,     7,     7,
       8,     7,     3,    11,     5,     7,     7,     8,     7,     3,
      11,     5,     7,     7,     8,     5,     3,    11,     5,     5,
       7,     8,     5,     3,    11,     5,    10,     7,     8,     6,
       3,    11,     5,     7,     7,     8,     6,     3,    11,     5,
       9,     7,     8,    10,     3,    11,     5,    10,     7,     8,
      10,     3,    11,     5,    10,     7,     8,    10,     3,    11,
       5,    10,     7,     8,    10,     3,    11,     5,    10,     7,
       8,    10,     3,    11,     5,    10,     7,     8,    10,     3,
      11,     5,    10,     7,     8,    10,     3,    11,     5,    10,
       7,     8,    10,     3,    11,     5,    10,     7,     8,    10,
       3,    11,     5,    10,     7,     8,    10,     3,    11,     5,
      10,     7,     8,    10,     3,    11,     5,    10,     7,     8,
      10,     3,    11,     5,    10,     7,     8,    10,     3,    11,
       5,    10,     7,     8,    10,     3,    11,     5,    10,     7,
       8,    10,     3,    11,     5,    10,     7,     8,    10,     3,
      11,     5,    10,     7,     8,    10,     3,    11,     5,    10,
       7,     8,    10,     3,    11,     5,    10,     7,     8,    10,
       3,    11,     5,    10,     7,     8,    10,     3,    11,     5,
      10,     7,     8,    10,     3,    11,     5,    10,     7,     8,
      10,     3,    11,     5,    10,     7,     8,    10,     3,    11,
       5,    10,     7,     8,    10,     3,    11,     5,    10,     7,
       8,    10,     3,    11,     5,    10,     7,     8,    10,     3,
      11,     5,    10,     7,     8,    10,     3,    11,     5,    10,
       7,     8,    10,     3,    11,     5,    10,     7,     8,    10,
       3,    11,     5,    10,     7,     8,    10,     3,    11,     5,
      10,     7,     8,    10,     3,    11,     5,    10,     7,     8,
      10,     3,    11,     5,    10,     7,     8,    10,     3,    11,
       5,    10,     7,     8,    10,     3,    11,     5,    10,     7,
       8,    10,     3,    11,     5,    10,     3,     8,     5,     7,
      11,     8,     7,     3,    11,     5,     7,     3,     8,     5,
       7,    11,     8,     7,     3,    11,     5,     7,     3,     8,
       5,     7,    11,     8,     8,     7,    11,    11,    12,    13,
      14,     8,     7,     7,    11,    12,    13,    14,     8,     7,
       7,    11,    12,    13,    14,     8,     7,     7,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    11,    12,    13,    14,     7,     7,    10,    -1,
      -1,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,     7,     7,
       7,     7,     7,     7,    -1,     7,     9,     7,     9,     7,
       9,     7,     9,     7,     9,    -1,     9,     9,     9,     9,
       9,     9
  };

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
  const unsigned char
  parser::yystos_[] =
  {
         0,   106,     0,    16,    17,   109,   107,     4,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   110,
       4,    18,    19,    20,    21,    22,    23,   108,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     3,     5,
       8,    11,   111,   111,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     5,     5,     5,     3,     5,     6,     6,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,   111,   111,
      11,    12,    13,    14,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,     7,   111,     7,   111,     7,
     111,     7,   111,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,   111,     7,     7,   111,     7,     7,
     111,     7,     7,   111,     7,   111,     7,   111,     7,   111,
       7,   111,     7,   111,     7,   111,     7,   111,     7,   111,
       7,     7,   111,     7,   111,     7,   111,     7,   111,     7,
     111,     7,   111,     7,   111,     7,   111,     7,   111,     7,
     111,     7,   111,     7,   111,     7,   111,   111,     7,   111,
     111,     7,   111,     7,   111,   111,   111,     7,   111,     7,
     111,   111,     7,   111,     7,   111,   111,     7,   111,     7,
     111,   111,   111,     9,   111,   111,   111,   111,     8,   111,
       8,   111,     8,   111,   111,   111,     8,   111,     8,   111,
       8,   111,     7,     7,     7,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,     7,     8,     7,     8,     7,     8,     7,
       8,     7,     8,     7,     8,     7,   111,     7,   111,   111,
     111,     7,   111,     7,   111,     7,   111,     7,   111,     7,
     111,     7,     7,     7,   111,     7,     7,   111,     7,     7,
     111,     7,     7,   111,     7,   111,     7,   111,   111,     7,
     111,   111,     7,   111,   111,     7,   111,     7,   111,     7,
     111,     7,   111,     7,   111,     7,   111,     7,   111,     7,
     111,     7,   111,     7,   111,     7,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,     9,
       7,     9,     7,     9,     7,     9,     7,     9,     7,     9,
       7,     9,     9,     9,     9,     9,     9
  };

#if YYDEBUG
  /* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
     to YYLEX-NUM.  */
  const unsigned short int
  parser::yytoken_number_[] =
  {
         0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359
  };
#endif

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
  const unsigned char
  parser::yyr1_[] =
  {
         0,   105,   106,   106,   106,   107,   107,   108,   108,   108,
     108,   108,   108,   108,   108,   109,   109,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   111,   111,   111,   111,   111,   111,   111,
     111
  };

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
  const unsigned char
  parser::yyr2_[] =
  {
         0,     2,     0,     3,     3,     0,     2,     1,     2,     2,
       2,     2,     2,     2,     2,     0,     2,     1,     6,     4,
       6,     4,     6,     4,     6,     4,     6,     4,     6,     4,
       6,     4,     6,     6,     4,     6,     4,     2,     4,     2,
       4,     2,     6,     4,     6,     4,     6,     6,     4,     6,
       6,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     4,     2,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     6,     4,     6,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     6,     4,
       6,     6,     4,     6,     6,     6,     6,     4,     4,     6,
       6,     6,     6,     4,     6,     6,     6,     6,     4,     6,
       6,     6,     6,     4,     4,     2,     2,     2,     2,     7,
       6,     7,     6,     7,     6,     4,     4,     7,     6,     4,
       7,     6,     7,     6,     4,     2,     2,     2,     2,     4,
       4,     1,     1,     3,     3,     3,     3,     2,     3,     1,
       1
  };

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const parser::yytname_[] =
  {
    "\"end of file\"", "error", "$undefined", "\"label\"",
  "\"label definition\"", "\"integer\"", "\"string\"", "\"register\"",
  "\"(\"", "\")\"", "\",\"", "EXP_SUB", "EXP_ADD", "EXP_DIV", "EXP_MUL",
  "EXP_UMINUS", "\".text\"", "\".data\"", "\".space\"", "\".byte\"",
  "\".half\"", "\".word\"", "\".ascii\"", "\".asciiz\"", "\"add\"",
  "\"addu\"", "\"addi\"", "\"addiu\"", "\"sub\"", "\"subu\"", "\"neg\"",
  "\"negu\"", "\"abs\"", "\"mul\"", "\"div\"", "\"divu\"", "\"rem\"",
  "\"remu\"", "\"sll\"", "\"sllv\"", "\"sra\"", "\"srav\"", "\"srl\"",
  "\"srlv\"", "\"rol\"", "\"ror\"", "\"and\"", "\"andi\"", "\"or\"",
  "\"ori\"", "\"xor\"", "\"xori\"", "\"nor\"", "\"not\"", "\"seq\"",
  "\"sne\"", "\"sge\"", "\"sgeu\"", "\"sgt\"", "\"sgtu\"", "\"sle\"",
  "\"sleu\"", "\"slt\"", "\"sltu\"", "\"slti\"", "\"sltiu\"", "\"beq\"",
  "\"beqz\"", "\"bne\"", "\"bnez\"", "\"bge\"", "\"bgeu\"", "\"bgez\"",
  "\"bgezal\"", "\"bgt\"", "\"bgtu\"", "\"bgtz\"", "\"ble\"", "\"bleu\"",
  "\"blez\"", "\"blt\"", "\"bltu\"", "\"bltz\"", "\"bltzal\"", "\"j\"",
  "\"jal\"", "\"jr\"", "\"jalr\"", "\"lb\"", "\"lbu\"", "\"lw\"",
  "\"lui\"", "\"li\"", "\"la\"", "\"sb\"", "\"sw\"", "\"move\"",
  "\"mfhi\"", "\"mflo\"", "\"mthi\"", "\"mtlo\"", "\"mfc0\"", "\"mtc0\"",
  "\"syscall\"", "\"nop\"", "$accept", "program", "datas", "data",
  "instructions", "instruction", "exp", 0
  };
#endif

#if YYDEBUG
  /* YYRHS -- A `-1'-separated list of the rules' RHS.  */
  const parser::rhs_number_type
  parser::yyrhs_[] =
  {
       106,     0,    -1,    -1,   106,    16,   109,    -1,   106,    17,
     107,    -1,    -1,   107,   108,    -1,     4,    -1,    18,     5,
      -1,    19,     5,    -1,    20,     5,    -1,    21,     5,    -1,
      21,     3,    -1,    22,     6,    -1,    23,     6,    -1,    -1,
     109,   110,    -1,     4,    -1,    24,     7,    10,     7,    10,
       7,    -1,    24,     7,    10,     7,    -1,    24,     7,    10,
       7,    10,   111,    -1,    24,     7,    10,   111,    -1,    25,
       7,    10,     7,    10,     7,    -1,    25,     7,    10,     7,
      -1,    25,     7,    10,     7,    10,   111,    -1,    25,     7,
      10,   111,    -1,    26,     7,    10,     7,    10,   111,    -1,
      26,     7,    10,   111,    -1,    27,     7,    10,     7,    10,
     111,    -1,    27,     7,    10,   111,    -1,    28,     7,    10,
       7,    10,     7,    -1,    28,     7,    10,     7,    -1,    28,
       7,    10,     7,    10,   111,    -1,    29,     7,    10,     7,
      10,     7,    -1,    29,     7,    10,     7,    -1,    29,     7,
      10,     7,    10,   111,    -1,    30,     7,    10,     7,    -1,
      30,     7,    -1,    31,     7,    10,     7,    -1,    31,     7,
      -1,    32,     7,    10,     7,    -1,    32,     7,    -1,    33,
       7,    10,     7,    10,     7,    -1,    33,     7,    10,     7,
      -1,    33,     7,    10,     7,    10,   111,    -1,    34,     7,
      10,     7,    -1,    34,     7,    10,     7,    10,     7,    -1,
      34,     7,    10,     7,    10,   111,    -1,    35,     7,    10,
       7,    -1,    35,     7,    10,     7,    10,     7,    -1,    35,
       7,    10,     7,    10,   111,    -1,    36,     7,    10,     7,
      10,     7,    -1,    36,     7,    10,     7,    -1,    37,     7,
      10,     7,    10,     7,    -1,    37,     7,    10,     7,    -1,
      38,     7,    10,     7,    10,   111,    -1,    38,     7,    10,
     111,    -1,    38,     7,    10,     7,    10,     7,    -1,    38,
       7,    10,     7,    -1,    39,     7,    10,     7,    10,     7,
      -1,    39,     7,    10,     7,    -1,    40,     7,    10,     7,
      10,   111,    -1,    40,     7,    10,   111,    -1,    40,     7,
      10,     7,    10,     7,    -1,    40,     7,    10,     7,    -1,
      41,     7,    10,     7,    10,     7,    -1,    41,     7,    10,
       7,    -1,    42,     7,    10,     7,    10,   111,    -1,    42,
       7,    10,   111,    -1,    42,     7,    10,     7,    10,     7,
      -1,    42,     7,    10,     7,    -1,    43,     7,    10,     7,
      10,     7,    -1,    43,     7,    10,     7,    -1,    44,     7,
      10,     7,    10,     7,    -1,    44,     7,    10,     7,    -1,
      44,     7,    10,     7,    10,   111,    -1,    44,     7,    10,
     111,    -1,    45,     7,    10,     7,    10,     7,    -1,    45,
       7,    10,     7,    -1,    45,     7,    10,     7,    10,   111,
      -1,    45,     7,    10,   111,    -1,    46,     7,    10,     7,
      10,     7,    -1,    46,     7,    10,     7,    -1,    46,     7,
      10,     7,    10,   111,    -1,    46,     7,    10,   111,    -1,
      47,     7,    10,     7,    10,   111,    -1,    47,     7,    10,
     111,    -1,    48,     7,    10,     7,    10,     7,    -1,    48,
       7,    10,     7,    -1,    48,     7,    10,     7,    10,   111,
      -1,    48,     7,    10,   111,    -1,    49,     7,    10,     7,
      10,   111,    -1,    49,     7,    10,   111,    -1,    50,     7,
      10,     7,    10,     7,    -1,    50,     7,    10,     7,    -1,
      50,     7,    10,     7,    10,   111,    -1,    50,     7,    10,
     111,    -1,    51,     7,    10,     7,    10,   111,    -1,    51,
       7,    10,   111,    -1,    52,     7,    10,     7,    10,     7,
      -1,    52,     7,    10,     7,    -1,    52,     7,    10,     7,
      10,   111,    -1,    52,     7,    10,   111,    -1,    53,     7,
      10,     7,    -1,    53,     7,    -1,    54,     7,    10,     7,
      10,     7,    -1,    54,     7,    10,     7,    -1,    54,     7,
      10,     7,    10,   111,    -1,    54,     7,    10,   111,    -1,
      55,     7,    10,     7,    10,     7,    -1,    55,     7,    10,
       7,    -1,    55,     7,    10,     7,    10,   111,    -1,    55,
       7,    10,   111,    -1,    56,     7,    10,     7,    10,     7,
      -1,    56,     7,    10,     7,    -1,    56,     7,    10,     7,
      10,   111,    -1,    56,     7,    10,   111,    -1,    57,     7,
      10,     7,    10,     7,    -1,    57,     7,    10,     7,    -1,
      57,     7,    10,     7,    10,   111,    -1,    57,     7,    10,
     111,    -1,    58,     7,    10,     7,    10,     7,    -1,    58,
       7,    10,     7,    10,   111,    -1,    58,     7,    10,   111,
      -1,    59,     7,    10,     7,    10,     7,    -1,    59,     7,
      10,     7,    10,   111,    -1,    59,     7,    10,   111,    -1,
      60,     7,    10,     7,    10,     7,    -1,    60,     7,    10,
       7,    -1,    60,     7,    10,     7,    10,   111,    -1,    60,
       7,    10,   111,    -1,    61,     7,    10,     7,    10,     7,
      -1,    61,     7,    10,     7,    -1,    61,     7,    10,     7,
      10,   111,    -1,    61,     7,    10,   111,    -1,    62,     7,
      10,     7,    10,     7,    -1,    62,     7,    10,     7,    -1,
      62,     7,    10,     7,    10,   111,    -1,    62,     7,    10,
     111,    -1,    63,     7,    10,     7,    10,     7,    -1,    63,
       7,    10,     7,    -1,    63,     7,    10,     7,    10,   111,
      -1,    63,     7,    10,   111,    -1,    64,     7,    10,     7,
      10,   111,    -1,    64,     7,    10,   111,    -1,    65,     7,
      10,     7,    10,   111,    -1,    65,     7,    10,   111,    -1,
      66,     7,    10,     7,    10,   111,    -1,    66,     7,    10,
     111,    10,   111,    -1,    67,     7,    10,   111,    -1,    68,
       7,    10,     7,    10,   111,    -1,    68,     7,    10,   111,
      10,   111,    -1,    69,     7,    10,   111,    -1,    70,     7,
      10,     7,    10,   111,    -1,    70,     7,    10,   111,    10,
     111,    -1,    71,     7,    10,     7,    10,   111,    -1,    71,
       7,    10,   111,    10,   111,    -1,    72,     7,    10,   111,
      -1,    73,     7,    10,   111,    -1,    74,     7,    10,     7,
      10,   111,    -1,    74,     7,    10,   111,    10,   111,    -1,
      75,     7,    10,     7,    10,   111,    -1,    75,     7,    10,
     111,    10,   111,    -1,    76,     7,    10,   111,    -1,    77,
       7,    10,     7,    10,   111,    -1,    77,     7,    10,   111,
      10,   111,    -1,    78,     7,    10,     7,    10,   111,    -1,
      78,     7,    10,   111,    10,   111,    -1,    79,     7,    10,
     111,    -1,    80,     7,    10,     7,    10,   111,    -1,    80,
       7,    10,   111,    10,   111,    -1,    81,     7,    10,     7,
      10,   111,    -1,    81,     7,    10,   111,    10,   111,    -1,
      82,     7,    10,   111,    -1,    83,     7,    10,   111,    -1,
      84,   111,    -1,    85,   111,    -1,    86,     7,    -1,    87,
       7,    -1,    88,     7,    10,   111,     8,     7,     9,    -1,
      88,     7,    10,     8,     7,     9,    -1,    89,     7,    10,
     111,     8,     7,     9,    -1,    89,     7,    10,     8,     7,
       9,    -1,    90,     7,    10,   111,     8,     7,     9,    -1,
      90,     7,    10,     8,     7,     9,    -1,    91,     7,    10,
     111,    -1,    92,     7,    10,   111,    -1,    93,     7,    10,
     111,     8,     7,     9,    -1,    93,     7,    10,     8,     7,
       9,    -1,    93,     7,    10,   111,    -1,    94,     7,    10,
     111,     8,     7,     9,    -1,    94,     7,    10,     8,     7,
       9,    -1,    95,     7,    10,   111,     8,     7,     9,    -1,
      95,     7,    10,     8,     7,     9,    -1,    96,     7,    10,
       7,    -1,    97,     7,    -1,    98,     7,    -1,    99,     7,
      -1,   100,     7,    -1,   101,     7,    10,     7,    -1,   102,
       7,    10,     7,    -1,   103,    -1,   104,    -1,   111,    12,
     111,    -1,   111,    11,   111,    -1,   111,    14,   111,    -1,
     111,    13,   111,    -1,    11,   111,    -1,     8,   111,     9,
      -1,     5,    -1,     3,    -1
  };

  /* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
     YYRHS.  */
  const unsigned short int
  parser::yyprhs_[] =
  {
         0,     0,     3,     4,     8,    12,    13,    16,    18,    21,
      24,    27,    30,    33,    36,    39,    40,    43,    45,    52,
      57,    64,    69,    76,    81,    88,    93,   100,   105,   112,
     117,   124,   129,   136,   143,   148,   155,   160,   163,   168,
     171,   176,   179,   186,   191,   198,   203,   210,   217,   222,
     229,   236,   243,   248,   255,   260,   267,   272,   279,   284,
     291,   296,   303,   308,   315,   320,   327,   332,   339,   344,
     351,   356,   363,   368,   375,   380,   387,   392,   399,   404,
     411,   416,   423,   428,   435,   440,   447,   452,   459,   464,
     471,   476,   483,   488,   495,   500,   507,   512,   519,   524,
     531,   536,   543,   548,   553,   556,   563,   568,   575,   580,
     587,   592,   599,   604,   611,   616,   623,   628,   635,   640,
     647,   652,   659,   666,   671,   678,   685,   690,   697,   702,
     709,   714,   721,   726,   733,   738,   745,   750,   757,   762,
     769,   774,   781,   786,   793,   798,   805,   810,   817,   824,
     829,   836,   843,   848,   855,   862,   869,   876,   881,   886,
     893,   900,   907,   914,   919,   926,   933,   940,   947,   952,
     959,   966,   973,   980,   985,   990,   993,   996,   999,  1002,
    1010,  1017,  1025,  1032,  1040,  1047,  1052,  1057,  1065,  1072,
    1077,  1085,  1092,  1100,  1107,  1112,  1115,  1118,  1121,  1124,
    1129,  1134,  1136,  1138,  1142,  1146,  1150,  1154,  1157,  1161,
    1163
  };

  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
  const unsigned short int
  parser::yyrline_[] =
  {
         0,   190,   190,   192,   193,   197,   199,   203,   207,   211,
     214,   217,   219,   222,   224,   228,   230,   234,   238,   244,
     249,   254,   258,   264,   269,   274,   278,   283,   287,   292,
     296,   302,   307,   312,   318,   323,   328,   333,   337,   342,
     346,   351,   355,   361,   366,   371,   376,   382,   387,   392,
     398,   403,   409,   414,   420,   425,   430,   434,   440,   445,
     451,   456,   461,   465,   471,   476,   482,   487,   492,   496,
     502,   507,   513,   518,   524,   529,   534,   538,   544,   549,
     554,   558,   564,   569,   574,   578,   583,   587,   593,   598,
     603,   607,   612,   616,   622,   627,   632,   636,   641,   645,
     651,   656,   661,   665,   670,   674,   680,   685,   690,   694,
     700,   705,   710,   714,   720,   725,   730,   734,   740,   745,
     750,   754,   760,   765,   769,   775,   780,   784,   790,   795,
     800,   804,   810,   815,   820,   824,   830,   835,   840,   844,
     850,   855,   860,   864,   869,   873,   878,   882,   887,   891,
     895,   900,   904,   908,   913,   917,   922,   926,   930,   934,
     939,   943,   948,   952,   956,   961,   965,   970,   974,   978,
     983,   987,   992,   996,  1000,  1004,  1007,  1010,  1014,  1018,
    1023,  1028,  1033,  1038,  1043,  1048,  1052,  1056,  1061,  1066,
    1070,  1075,  1080,  1085,  1090,  1095,  1099,  1103,  1107,  1111,
    1116,  1121,  1124,  1129,  1130,  1131,  1132,  1133,  1135,  1136,
    1137
  };

  // Print the state stack on the debug stream.
  void
  parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (state_stack_type::const_iterator i = yystate_stack_.begin ();
	 i != yystate_stack_.end (); ++i)
      *yycdebug_ << ' ' << *i;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "), ";
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
		       yyrhs_[yyprhs_[yyrule] + yyi],
		       &(yysemantic_stack_[(yynrhs) - (yyi + 1)]),
		       &(yylocation_stack_[(yynrhs) - (yyi + 1)]));
  }
#endif // YYDEBUG

  /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
  parser::token_number_type
  parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
           0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104
    };
    if ((unsigned int) t <= yyuser_token_number_max_)
      return translate_table[t];
    else
      return yyundef_token_;
  }

  const int parser::yyeof_ = 0;
  const int parser::yylast_ = 921;
  const int parser::yynnts_ = 7;
  const int parser::yyempty_ = -2;
  const int parser::yyfinal_ = 2;
  const int parser::yyterror_ = 1;
  const int parser::yyerrcode_ = 256;
  const int parser::yyntokens_ = 105;

  const unsigned int parser::yyuser_token_number_max_ = 359;
  const parser::token_number_type parser::yyundef_token_ = 2;

} // namespace yy

#line 1139 "asm-parse.yy"

void
yy::parser::error(const location &l, const std::string &msg)
{
  std::cerr << l << ": " << msg << std::endl;
  exit_set (exit_parse);
}


